#include "SPAServer.h"

#include "spdlog/spdlog.h"
#include "CurlHttp.h"
#include <filesystem>
#include "CurlFtp.h"
#include "ThreadPool/ThreadPool.h"

#include <QVector>


SPAServer::SPAServer()
{
    m_logger = spdlog::get("SPAServer");
    if(m_logger == nullptr)
    {
        SPDLOG_ERROR("APAServer logger is nullptr");
        return;
    }

    m_threadRunning = true;


    // m_fromSuperBrain.getToken();
    // m_fromSuperBrain.getTaskTypeList(m_vecAlgorithmInfo);
    // m_fromSuperBrain.getDeviceList(m_vecDeviceInfo);

    // for(const auto& it : m_vecAlgorithmInfo)
    // {
    //     SPDLOG_LOGGER_INFO(m_logger, "ActionID:{} ActionName:{} ActionTaskID:{}", it.ActionID, it.ActionName, it.ActionTaskID);
    // }
    // for(const auto& it : m_vecDeviceInfo)
    // {
    //     SPDLOG_LOGGER_INFO(m_logger, "DeviceID:{} DeviceName:{} DeviceType:{}", it.DeviceID, it.DeviceName, it.DeviceType);
    //     SPDLOG_LOGGER_INFO(m_logger, "Port:{} UserAccount:{} PWD:{}", it.DevicePort, it.UserAccount, it.UserPassword);
    //     SPDLOG_LOGGER_INFO(m_logger, "ActionID:{} ActionName:{} ActionTaskID:{}", it.vecAlgorithmInfo[0].ActionID, it.vecAlgorithmInfo[0].ActionName, it.vecAlgorithmInfo[0].ActionTaskID);
    // }

    // m_fromRedis.setRedisIPAndPort("172.16.36.80", 32222);
    // m_fromRedis.setRedisPassword("Ff1z@TOFr^iwd%Ra");
    // m_fromRedis.connectRedis();
    // std::string value;
    // m_fromRedis.getRedisString("113:P100104000", value);
    // SPDLOG_LOGGER_INFO(m_logger, "{}", value);
    // m_fromRedis.disConnectRedis();

    //|FTP|192.1.2.178:32021|lh|DWw7V9u0|

    m_toEQMDataBase.initWebApi("http://192.1.3.133:31000/v6/", "", "4c2f9fc91c22dd98331e47af2e2964f4");
    AlgorithmInfo info;
    info.ActionID = "123";
    info.ActionName = "test";
    info.ActionTaskID = 456;
    QVector<AlgorithmInfo> vecInfo;
    vecInfo.push_back(info);
    m_toEQMDataBase.writeAlgorithmInfo(vecInfo);
    
}

SPAServer::~SPAServer()
{

}

/* 启动服务 */
void SPAServer::startServer()
{
    /* 添加获取基础信息的线程 */
    CPPTP.add_task(&SPAServer::fromSuperBrainThread, this);
}


/**
 * @brief 从基础平台获取算法信息和设备信息的线程函数
 * 
 */
void SPAServer::fromSuperBrainThread()
{
    SPDLOG_LOGGER_DEBUG(m_logger, "开启 fromSuperBrainThread 线程");
    /* 获取一次token，后续失效了再获取 */
    m_fromSuperBrain.getToken();
    while (m_threadRunning)
    {
        SPDLOG_LOGGER_DEBUG(m_logger, "获取基础信息");
        std::vector<AlgorithmInfo> vecAlgInfo;
        std::vector<DeviceInfo> vecDevInfo;
        m_fromSuperBrain.getTaskTypeList(vecAlgInfo);
        m_fromSuperBrain.getDeviceList(vecDevInfo);

        /* 对比数据库表格信息 */
        std::vector<AlgorithmInfo> vecAlgUpdate;
        std::vector<AlgorithmInfo> vecAlgDelete;
        /* 取出要添加的 */
        for(const auto& it : vecAlgInfo)
        {
            for(const auto& it0 : m_vecEqmAlgInfo)
            {
                if(it.ActionID != it0.ActionID)
                {
                    vecAlgUpdate.push_back(it);
                }
            }
        }
        /* 取出要删除的 */
        for(const auto& it : m_vecEqmAlgInfo)
        {
            for(const auto& it0 : vecAlgInfo)
            {
                if(it.ActionID != it0.ActionID)
                {
                    vecAlgDelete.push_back(it);
                }
            }
        }

        std::this_thread::sleep_for(std::chrono::seconds(10));
    }
}



