#ifndef SPASERVER_H
#define SPASERVER_H

#include "FromSuperBrain.h"
#include "FromRedis.h"
#include "ToEQMDataBase.h"

/**
 * 安播辅助提示系统服务类
 * 
 */
class SPAServer
{
public:
    SPAServer();
    ~SPAServer();

    /* 启动服务 */
    void startServer();

private:
    /* 从基础平台获取算法信息和设备信息的线程函数 */
    void fromSuperBrainThread();


private:
    std::shared_ptr<spdlog::logger> m_logger = nullptr;

    bool m_threadRunning = true;                        /* 线程正在运行 */

    FromSuperBrain m_fromSuperBrain;
    FromRedis m_fromRedis;
    ToEQMDataBase m_toEQMDataBase;

    /* 算法信息，这个就是tAction在内存中的数据，方便后续对比，程序启动的时候会先获取一份 */
    std::vector<AlgorithmInfo> m_vecEqmAlgInfo;
    /* 设备信息，这个是tActionCamer的信息 */
    std::vector<DeviceInfo> m_vecEqmDevInfo;

};

#endif /* SPASERVER_H */
